searchNodes=[{"doc":"APIEarmark now exposes a well-defined and stable Abstract Syntax TreeEarmark.as_astThe function is described below and the other two API functions as_html and as_html! are now based upon the structure of the result of as_ast.{:ok, ast, []} = Earmark.as_ast(markdown) {:ok, ast, deprecation_messages} = Earmark.as_ast(markdown) {:error, ast, error_messages} = Earmark.as_ast(markdown)Earmark.as_html{:ok, html_doc, []} = Earmark.as_html(markdown) {:ok, html_doc, deprecation_messages} = Earmark.as_html(markdown) {:error, html_doc, error_messages} = Earmark.as_html(markdown)Earmark.as_html!html_doc = Earmark.as_html!(markdown, options)Formats the error_messages returned by as_html and adds the filename to each. Then prints them to stderr and just returns the html_docOptionsOptions can be passed into as_ast/2as well as as_html/2 or as_html!/2 according to the documentation.{status, html_doc, errors} = Earmark.as_html(markdown, options) html_doc = Earmark.as_html!(markdown, options) {status, ast, errors} = Earmark.as_ast(markdown, options)Command line$ mix escript.build $ ./earmark file.mdSome options defined in the Earmark.Options struct can be specified as command line switches.Use$ ./earmark --helpto find out more, but here is a short example$ ./earmark --smartypants false --code-class-prefix &quot;a- b-&quot; file.mdwill callEarmark.as_html!( ..., %Earmark.Options{smartypants: false, code_class_prefix: &quot;a- b-&quot;})SupportsStandard Gruber markdown.ExtensionsGithub Flavored MarkdownGFM is supported by default, however as GFM is a moving target and all GFM extension do not make sense in a general context, Earmark does not support all of it, here is a list of what is supported:Strike Throughiex(1)&gt; Earmark.as_html! [&quot;~~hello~~&quot;] &quot;&lt;p&gt;\\n &lt;del&gt;\\nhello &lt;/del&gt;\\n&lt;/p&gt;\\n&quot;Syntax HighlightingAll backquoted or fenced code blocks with a language string are rendered with the given language as a class attribute of the code tag.For example:iex(2)&gt; [ ...(2)&gt; &quot;```elixir&quot;, ...(2)&gt; &quot; @tag :hello&quot;, ...(2)&gt; &quot;```&quot; ...(2)&gt; ] |&gt; Earmark.as_html!() &quot;&lt;pre&gt;&lt;code class=\\&quot;elixir\\&quot;&gt; @tag :hello&lt;/code&gt;&lt;/pre&gt;\\n&quot;will be rendered as shown in the doctest above.If you want to integrate with a syntax highlighter with different conventions you can add more classes by specifying prefixes that will be put before the language string.Prism.js for example needs a class language-elixir. In order to achieve that goal you can add language- as a code_class_prefix to Earmark.Options.In the following example we want more than one additional class, so we add more prefixes.Earmark.as_html!(..., %Earmark.Options{code_class_prefix: &quot;lang- language-&quot;})which is rendering&lt;pre&gt;&lt;code class=&quot;elixir lang-elixir language-elixir&quot;&gt;...As for all other options code_class_prefix can be passed into the earmark executable as follows:earmark --code-class-prefix &quot;language- lang-&quot; ...TablesAre supported as long as they are preceded by an empty line.State | Abbrev | Capital ----: | :----: | ------- Texas | TX | Austin Maine | ME | AugustaTables may have leading and trailing vertical bars on each line| State | Abbrev | Capital | | ----: | :----: | ------- | | Texas | TX | Austin | | Maine | ME | Augusta |Tables need not have headers, in which case all column alignments default to left.| Texas | TX | Austin | | Maine | ME | Augusta |Currently we assume there are always spaces around interior vertical unless there are exterior bars.However in order to be more GFM compatible the gfm_tables: true option can be used to interpret only interior vertical bars as a table if a seperation line is given, therefor Language|Rating --------|------ Elixir | awesomeis a table (iff gfm_tables: true) while Language|Rating Elixir | awesomenever is.HTML BlocksHTML is not parsed recursively or detected in all conditons right now, though GFM compliance is a goal.But for now the following holds:A HTML Block defined by a tag starting a line and the same tag starting a different line is parsed as one HTML AST node, marked with %{verbatim: true}E.g. iex(3)&gt; lines = [ &quot;&lt;div&gt;&lt;span&gt;&quot;, &quot;some&lt;/span&gt;&lt;text&gt;&quot;, &quot;&lt;/div&gt;more text&quot; ] ...(3)&gt; Earmark.as_ast(lines) {:ok, [{&quot;div&quot;, [], [&quot;&lt;span&gt;&quot;, &quot;some&lt;/span&gt;&lt;text&gt;&quot;], %{verbatim: true}}, &quot;more text&quot;], []}And a line starting with an opening tag and ending with the corresponding closing tag is parsed in similar fashion iex(4)&gt; Earmark.as_ast([&quot;&lt;span class=\\&quot;superspan\\&quot;&gt;spaniel&lt;/span&gt;&quot;]) {:ok, [{&quot;span&quot;, [{&quot;class&quot;, &quot;superspan&quot;}], [&quot;spaniel&quot;], %{verbatim: true}}], []}What is HTML?We differ from strict GFM by allowing all tags not only HTML5 tagsn this holds for oneliners.... iex(5)&gt; {:ok, ast, []} = Earmark.as_ast([&quot;&lt;stupid /&gt;&quot;, &quot;&lt;not&gt;better&lt;/not&gt;&quot;]) ...(5)&gt; ast [ {&quot;stupid&quot;, [], [], %{verbatim: true}}, {&quot;not&quot;, [], [&quot;better&quot;], %{verbatim: true}}]and for multiline blocks iex(6)&gt; {:ok, ast, []} = Earmark.as_ast([ &quot;&lt;hello&gt;&quot;, &quot;world&quot;, &quot;&lt;/hello&gt;&quot;]) ...(6)&gt; ast [{&quot;hello&quot;, [], [&quot;world&quot;], %{verbatim: true}}]HTML CommentsAre recoginized if they start a line (after ws and are parsed until the next --&gt; is found all text after the next '--&gt;' is ignoredE.g.iex(7)&gt; Earmark.as_ast(&quot; &lt;!-- Comment\\ncomment line\\ncomment --&gt; text --&gt;\\nafter&quot;) {:ok, [{:comment, [], [&quot; Comment&quot;, &quot;comment line&quot;, &quot;comment &quot;], %{comment: true}}, {&quot;p&quot;, [], [&quot;after&quot;], %{}}], []}Adding HTML attributes with the IAL extensionTo block elementsHTML attributes can be added to any block-level element. We use the Kramdown syntax: add the line {: attrs } following the block.attrs can be one or more of:.className#idname=value, name=&quot;value&quot;, or name='value'For example:# Warning {: .red} Do not turn off the engine if you are at altitude. {: .boxed #warning spellcheck=&quot;true&quot;}To links or imagesIt is possible to add IAL attributes to generated links or images in the following format.iex(8)&gt; markdown = &quot;[link](url) {: .classy}&quot; ...(8)&gt; Earmark.as_html(markdown) { :ok, &quot;&lt;p&gt;\\n&lt;a class=\\&quot;classy\\&quot; href=\\&quot;url\\&quot;&gt;link&lt;/a&gt;&lt;/p&gt;\\n&quot;, []}For both cases, malformed attributes are ignored and warnings are issued.iex(9)&gt; [ &quot;Some text&quot;, &quot;{:hello}&quot; ] |&gt; Enum.join(&quot;\\n&quot;) |&gt; Earmark.as_html() {:error, &quot;&lt;p&gt;\\nSome text&lt;/p&gt;\\n&quot;, [{:warning, 2,&quot;Illegal attributes [\\&quot;hello\\&quot;] ignored in IAL&quot;}]}It is possible to escape the IAL in both forms if necessaryiex(10)&gt; markdown = &quot;[link](url)\\\\{: .classy}&quot; ...(10)&gt; Earmark.as_html(markdown) {:ok, &quot;&lt;p&gt;\\n&lt;a href=\\&quot;url\\&quot;&gt;link&lt;/a&gt;{: .classy}&lt;/p&gt;\\n&quot;, []}This of course is not necessary in code blocks or text lines containing an IAL-like string, as in the following exampleiex(11)&gt; markdown = &quot;hello {:world}&quot; ...(11)&gt; Earmark.as_html!(markdown) &quot;&lt;p&gt;\\nhello {:world}&lt;/p&gt;\\n&quot;LimitationsBlock-level HTML is correctly handled only if each HTML tag appears on its own line. So&lt;div&gt; &lt;div&gt; hello &lt;/div&gt; &lt;/div&gt; will work. However. the following won't &lt;div&gt; hello&lt;/div&gt;John Gruber's tests contain an ambiguity when it comes to lines that might be the start of a list inside paragraphs.One test says that This is the text * of a paragraph that I wroteis a single paragraph. The &quot;*&quot; is not significant. However, another test has * A list item * an anotherand expects this to be a nested list. But, in reality, the second could just be the continuation of a paragraph. I've chosen always to use the second interpretation—a line that looks like a list item will always be a list item.Rendering of block and inline elements.Block or void HTML elements that are at the absolute beginning of a line end the preceding paragraph. Thusly mypara &lt;hr /&gt;Becomes &lt;p&gt;mypara&lt;/p&gt; &lt;hr /&gt;While mypara &lt;hr /&gt;will be transformed into &lt;p&gt;mypara &lt;hr /&gt;&lt;/p&gt;TimeoutsBy default, that is if the timeout option is not set Earmark uses parallel mapping as implemented in Earmark.pmap/2, which uses Task.await with its default timeout of 5000ms.In rare cases that might not be enough.By indicating a longer timeout option in milliseconds Earmark will use parallel mapping as implemented in Earmark.pmap/3, which will pass timeout to Task.await.In both cases one can override the mapper function with either the mapper option (used if and only if timeout is nil) or the mapper_with_timeout function (used otherwise).For the escript only the timeout command line argument can be used.SecurityPlease be aware that Markdown is not a secure format. It produces HTML from Markdown and HTML. It is your job to sanitize and or filter the output of Earmark.as_html if you cannot trust the input and are to serve the produced HTML on the Web.","ref":"Earmark.html","title":"Earmark","type":"module"},{"doc":"iex(12)&gt; markdown = &quot;My `code` is **best**&quot; ...(12)&gt; {:ok, ast, []} = Earmark.as_ast(markdown) ...(12)&gt; ast [{&quot;p&quot;, [], [&quot;My &quot;, {&quot;code&quot;, [{&quot;class&quot;, &quot;inline&quot;}], [&quot;code&quot;], %{}}, &quot; is &quot;, {&quot;strong&quot;, [], [&quot;best&quot;], %{}}], %{}}]Options are passes like to as_html, some do not have an effect though (e.g. smartypants) as formatting and escaping is not done for the AST. iex(13)&gt; markdown = &quot;```elixir\\nIO.puts 42\\n```&quot; ...(13)&gt; {:ok, ast, []} = Earmark.as_ast(markdown, code_class_prefix: &quot;lang-&quot;) ...(13)&gt; ast [{&quot;pre&quot;, [], [{&quot;code&quot;, [{&quot;class&quot;, &quot;elixir lang-elixir&quot;}], [&quot;IO.puts 42&quot;], %{}}], %{}}]Rationale:The AST is exposed in the spirit of Floki's.","ref":"Earmark.html#as_ast/2","title":"Earmark.as_ast/2","type":"function"},{"doc":"Given a markdown document (as either a list of lines or a string containing newlines), returns a tuple containing either {:ok, html_doc, error_messages}, or {:error, html_doc, error_messages} Where html_doc is an HTML representation of the markdown document and error_messages is a list of tuples with the following elementsseverity e.g. :error, :warning or :deprecationline number in input where the error occurreddescription of the erroroptions can be an %Earmark.Options{} structure, or can be passed in as a Keyword argument (with legal keys for %Earmark.Optionsrenderer: ModuleNameThe module used to render the final document. Defaults to Earmark.HtmlRenderergfm: booleanTrue by default. Turns on the supported Github Flavored Markdown extensionsbreaks: booleanOnly applicable if gfm is enabled. Makes all line breaks significant (so every line in the input is a new line in the output.code_class_prefix: binaryCode blocks will be rendered with prefixed class names, which might be necessary for usage with 3rd party libraries. Earmark.as_html(&quot;```elixir\\nCode\\n```&quot;, code_class_prefix: &quot;my_prefix_&quot;) {:ok, &quot;&lt;pre&gt;&lt;code class=\\&quot;elixir my_prefix_elixir\\&quot;&gt;Code\\```&lt;/code&gt;&lt;/pre&gt;\\n&quot;, []}smartypants: booleanTurns on smartypants processing, so quotes become curly, two or three hyphens become en and em dashes, and so on. True by default. So, to format the document in original and disable smartypants, you'd call alias Earmark.Options Earmark.as_html(original, %Options{smartypants: false})pure_links: booleanPure links of the form ~r{\\bhttps?://\\S+\\b} are rendered as links from now on. However, by setting the pure_links option to false this can be disabled and pre 1.4 behavior can be used.","ref":"Earmark.html#as_html/2","title":"Earmark.as_html/2","type":"function"},{"doc":"A convenience method that always returns an HTML representation of the markdown document passed in. In case of the presence of any error messages they are prinetd to stderr.Otherwise it behaves exactly as as_html.","ref":"Earmark.html#as_html!/2","title":"Earmark.as_html!/2","type":"function"},{"doc":"Accesses current hex version of the Earmark application. Convenience for iex usage.","ref":"Earmark.html#version/0","title":"Earmark.version/0","type":"function"},{"doc":"","ref":"Earmark.html#t:ast/0","title":"Earmark.ast/0","type":"type"},{"doc":"","ref":"Earmark.html#t:ast_attribute/0","title":"Earmark.ast_attribute/0","type":"type"},{"doc":"","ref":"Earmark.html#t:ast_attribute_name/0","title":"Earmark.ast_attribute_name/0","type":"type"},{"doc":"","ref":"Earmark.html#t:ast_attribute_value/0","title":"Earmark.ast_attribute_value/0","type":"type"},{"doc":"","ref":"Earmark.html#t:ast_attributes/0","title":"Earmark.ast_attributes/0","type":"type"},{"doc":"","ref":"Earmark.html#t:ast_meta/0","title":"Earmark.ast_meta/0","type":"type"},{"doc":"","ref":"Earmark.html#t:ast_node/0","title":"Earmark.ast_node/0","type":"type"},{"doc":"","ref":"Earmark.html#t:ast_tag/0","title":"Earmark.ast_tag/0","type":"type"},{"doc":"","ref":"Earmark.html#t:ast_tuple/0","title":"Earmark.ast_tuple/0","type":"type"},{"doc":"","ref":"Earmark.Options.html","title":"Earmark.Options","type":"module"},{"doc":"","ref":"Earmark.Options.html#t:inline_code_continuation/0","title":"Earmark.Options.inline_code_continuation/0","type":"type"},{"doc":"","ref":"Earmark.Options.html#t:maybe/1","title":"Earmark.Options.maybe/1","type":"type"},{"doc":"","ref":"Earmark.Options.html#t:message/0","title":"Earmark.Options.message/0","type":"type"},{"doc":"","ref":"Earmark.Options.html#t:message_type/0","title":"Earmark.Options.message_type/0","type":"type"},{"doc":"","ref":"Earmark.Options.html#t:numbered_line/0","title":"Earmark.Options.numbered_line/0","type":"type"},{"doc":"","ref":"Earmark.Options.html#t:t/0","title":"Earmark.Options.t/0","type":"type"},{"doc":"","ref":"Earmark.Options.html#t:token/0","title":"Earmark.Options.token/0","type":"type"},{"doc":"","ref":"Earmark.Options.html#t:tokens/0","title":"Earmark.Options.tokens/0","type":"type"},{"doc":"","ref":"Earmark.Parser.ListParser.Ctxt.html","title":"Earmark.Parser.ListParser.Ctxt","type":"module"},{"doc":"Public Interface to functions operating on the AST exposed by Earmark.as_ast","ref":"Earmark.Transform.html","title":"Earmark.Transform","type":"module"},{"doc":"Needs update for 1.4.7","ref":"Earmark.Transform.html#transform/2","title":"Earmark.Transform.transform/2","type":"function"}]